commit 2f6dc9041face60fe39a85f63b5b3fdf0fc936b1
Author: leszek <leszek@koltunski.pl>
Date:   Mon Dec 9 23:53:39 2024 +0100

    minor

diff --git a/src/main/java/org/distorted/objectlib/effects/BaseEffect.java b/src/main/java/org/distorted/objectlib/effects/BaseEffect.java
index ebf3da67..787bfb2f 100644
--- a/src/main/java/org/distorted/objectlib/effects/BaseEffect.java
+++ b/src/main/java/org/distorted/objectlib/effects/BaseEffect.java
@@ -33,9 +33,9 @@ public class BaseEffect
     SOLVE         ( 20, 1, R.string.solve_effect        , SolveEffect.class       ),
     SCRAMBLE      ( 60, 1, R.string.scramble_effect     , ScrambleEffect.class    ),
     FAST_SCRAMBLE ( 20, 0, R.string.fast_scramble_effect, FastScrambleEffect.class),
-    PRESENT       (100, 0, R.string.present_effect, PresentEffect.class),
+    PRESENT       (100, 0, R.string.present_effect      , PresentEffect.class     ),
     WIN           ( 20, 1, R.string.win_effect          , WinEffect.class         ),
-    RESTICKER     ( 20, 0, R.string.resticker_effect          , RestickerEffect.class         ),
+    RESTICKER     ( 20, 0, R.string.resticker_effect    , RestickerEffect.class   ),
     ;
 
     private final int mDefaultPos, mDefaultType;
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index 1aa02ceb..b1a0dd7c 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -183,7 +183,7 @@ public abstract class TwistyObject extends TwistyObjectTheoretical
       types[c] = getCubitRotationType(c);
       }
 
-    super.initialize(axis, angles, positions, cuts, offsets, types, minCubits, faceAxis);
+    super.initialize(axis, angles, positions, cuts, minCubits, offsets, types, faceAxis);
 
     mIconMode = iconMode;
     mQuat = quat;
@@ -1677,62 +1677,14 @@ public abstract class TwistyObject extends TwistyObjectTheoretical
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected void setReader(JsonReader reader)
-    {
-    // empty
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public String getInventor()
-    {
-    return mMetadata.getAuthor();
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public int getYearOfInvention()
-    {
-    return mMetadata.getYearOfInvention();
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public float getComplexity()
-    {
-    return mMetadata.getDifficulty();
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public String getObjectName()
-    {
-    return mMetadata.getObjectName();
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public ObjectSignature getSignature()
-    {
-    return mMetadata.getSignature();
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public int getCategory()
-    {
-    if( mMetadata!=null ) return mMetadata.getCategory();
-
-    android.util.Log.e("D", "TwistyObject.getCategory(): metadata null!");
-    return 0;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public boolean isSubmittable()
-    {
-    return mCurrentColorSchemeSubmittable;
-    }
+  protected void setReader(JsonReader reader) { }
+  public String getInventor()                 { return mMetadata.getAuthor(); }
+  public int getYearOfInvention()             { return mMetadata.getYearOfInvention(); }
+  public float getComplexity()                { return mMetadata.getDifficulty(); }
+  public String getObjectName()               { return mMetadata.getObjectName(); }
+  public ObjectSignature getSignature()       { return mMetadata.getSignature(); }
+  public int getCategory()                    { return mMetadata!=null ? mMetadata.getCategory() : 0; }
+  public boolean isSubmittable()              { return mCurrentColorSchemeSubmittable; }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
   // for JSON only
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java b/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java
index 2b2d5e41..64761565 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObjectTheoretical.java
@@ -40,7 +40,8 @@ public class TwistyObjectTheoretical
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  void initialize(Static3D[] axis, int[][] angles, float[][] positions, float[][] cuts, float[][] offsets, int[] types, int[][] minCubits, Static3D[] faceAxis)
+  void initialize(Static3D[] axis, int[][] angles, float[][] positions, float[][] cuts,
+                  int[][] minCubits, float[][] offsets, int[] types, Static3D[] faceAxis)
     {
     mAxis = axis;
     mFaceAxis = faceAxis;