commit ecc015911ada8bc1a34b34437dd0f7fbd3a3a7e7
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Thu Apr 21 01:01:14 2022 +0200

    Progress with cubit quaternions.

diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java b/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java
index ecce1f1d..6bf68ab6 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java
@@ -215,21 +215,21 @@ public class TwistyTrajber extends ShapeOctahedron
         {
         mPositions = new float[][]
             {
+              {  -LEN,       0,   LEN},
+              {   LEN,       0,  -LEN},
               {   LEN,       0,   LEN},
               {  -LEN,       0,  -LEN},
               {     0, SQ2*LEN,     0},
               {     0,-SQ2*LEN,     0},
-              {  -LEN,       0,   LEN},
-              {   LEN,       0,  -LEN},
 
-              {-LEN/2, (SQ2/2)*LEN, LEN/2},
-              { LEN/2, (SQ2/2)*LEN,-LEN/2},
-              {-LEN/2,-(SQ2/2)*LEN, LEN/2},
-              { LEN/2,-(SQ2/2)*LEN,-LEN/2},
               {     0,     0,   LEN},
               {   LEN,     0,     0},
               {  -LEN,     0,     0},
               {     0,     0,  -LEN},
+              {-LEN/2, (SQ2/2)*LEN, LEN/2},
+              { LEN/2, (SQ2/2)*LEN,-LEN/2},
+              {-LEN/2,-(SQ2/2)*LEN, LEN/2},
+              { LEN/2,-(SQ2/2)*LEN,-LEN/2},
               { LEN/2, (SQ2/2)*LEN, LEN/2},
               { LEN/2,-(SQ2/2)*LEN, LEN/2},
               {-LEN/2, (SQ2/2)*LEN,-LEN/2},
@@ -260,6 +260,12 @@ public class TwistyTrajber extends ShapeOctahedron
 
         mPositions = new float[][]
             {
+              {  -I+B,  A,  I   },
+              {  -I+B, -A,  I   },
+              {   I  ,  A, -I+B },
+              {   I  , -A, -I+B },
+              {   I-B, -A, -I   },
+              {   I-B,  A, -I   },
               {   I  ,  A,  I-B },
               {   I  , -A,  I-B },
               {   I-B, -A,  I   },
@@ -278,21 +284,6 @@ public class TwistyTrajber extends ShapeOctahedron
               {     0, -J, -B   },
               {  -I  , -A,  I-B },
               {  -I  ,  A,  I-B },
-              {  -I+B,  A,  I   },
-              {  -I+B, -A,  I   },
-              {   I  ,  A, -I+B },
-              {   I  , -A, -I+B },
-              {   I-B, -A, -I   },
-              {   I-B,  A, -I   },
-
-              {-D*LEN, F*LEN, E*LEN },
-              {-E*LEN, F*LEN, D*LEN },
-              { E*LEN, F*LEN,-D*LEN},
-              { D*LEN, F*LEN,-E*LEN},
-              {-D*LEN,-F*LEN, E*LEN },
-              {-E*LEN,-F*LEN, D*LEN },
-              { E*LEN,-F*LEN,-D*LEN},
-              { D*LEN,-F*LEN,-E*LEN},
 
               {     0, G*LEN, H*LEN},
               {     0,-G*LEN, H*LEN},
@@ -303,6 +294,15 @@ public class TwistyTrajber extends ShapeOctahedron
               {     0, G*LEN,-H*LEN},
               {     0,-G*LEN,-H*LEN},
 
+              {-D*LEN, F*LEN, E*LEN },
+              {-E*LEN, F*LEN, D*LEN },
+              { E*LEN, F*LEN,-D*LEN},
+              { D*LEN, F*LEN,-E*LEN},
+              {-D*LEN,-F*LEN, E*LEN },
+              {-E*LEN,-F*LEN, D*LEN },
+              { E*LEN,-F*LEN,-D*LEN},
+              { D*LEN,-F*LEN,-E*LEN},
+
               {+D*LEN, F*LEN,+E*LEN},
               {+E*LEN, F*LEN,+D*LEN},
               {+D*LEN,-F*LEN,+E*LEN},
@@ -335,14 +335,14 @@ public class TwistyTrajber extends ShapeOctahedron
       {
       if( numLayers[0]==3 )
         {
-        mQuatIndex = new int[] { 6, 4, 1, 3, 0, 2,
-                                 7,19, 9,18, 0, 2, 8, 5, 1, 3,14,11,
+        mQuatIndex = new int[] { 0, 2, 6, 4, 1, 3,
+                                 0, 2, 8, 5, 7,19, 9,18, 1, 3,14,11,
                                  0, 1, 3, 2, 7, 5, 8,16 };
         }
       else
         {
-        mQuatIndex = new int[] { 6,12,17,21,20, 4,10,16, 1,14,15,13,23,22, 3,11, 8, 7, 0, 9,19, 2,18, 5,
-                                15, 7,19,13, 9,22,23,18, 0,17, 6, 2, 4, 8, 5,16,21, 1, 3,12,10,14,11,20,
+        mQuatIndex = new int[] { 0, 9,19, 2,18, 5, 6,12,17,21,20, 4,10,16, 1,14,15,13,23,22, 3,11, 8, 7,
+                                 0,17, 6, 2, 4, 8, 5,16,15, 7,19,13, 9,22,23,18,21, 1, 3,12,10,14,11,20,
                                  0, 1, 3, 2, 7, 5, 8,16 };
         }
       }