commit bc39861d931d2536e02c5ef1131ffdd99a17b19d
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Mon Dec 20 23:27:08 2021 +0100

    Trajber's Octahedron: add object to the system.

diff --git a/src/main/java/org/distorted/objectlib/main/ObjectConstants.java b/src/main/java/org/distorted/objectlib/main/ObjectConstants.java
index f8e6aeb5..1fbab3b6 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectConstants.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectConstants.java
@@ -31,15 +31,19 @@ public class ObjectConstants
   public static final int CUBE_7 = ObjectType.CUBE_7.ordinal();
   public static final int MIRR_2 = ObjectType.MIRR_2.ordinal();
   public static final int MIRR_3 = ObjectType.MIRR_3.ordinal();
-  public static final int JING_2 = ObjectType.JING_2.ordinal();
-  public static final int PYRA_3 = ObjectType.PYRA_3.ordinal();
-  public static final int PYRA_4 = ObjectType.PYRA_4.ordinal();
-  public static final int PYRA_5 = ObjectType.PYRA_5.ordinal();
+  public static final int CU_323 = ObjectType.CU_323.ordinal();
+  public static final int CU_232 = ObjectType.CU_232.ordinal();
+  public static final int CU_343 = ObjectType.CU_343.ordinal();
+  public static final int ULTI_2 = ObjectType.ULTI_2.ordinal();
   public static final int KILO_3 = ObjectType.KILO_3.ordinal();
   public static final int KILO_5 = ObjectType.KILO_5.ordinal();
   public static final int MEGA_3 = ObjectType.MEGA_3.ordinal();
   public static final int MEGA_5 = ObjectType.MEGA_5.ordinal();
-  public static final int ULTI_2 = ObjectType.ULTI_2.ordinal();
+  public static final int JING_2 = ObjectType.JING_2.ordinal();
+  public static final int PYRA_3 = ObjectType.PYRA_3.ordinal();
+  public static final int PYRA_4 = ObjectType.PYRA_4.ordinal();
+  public static final int PYRA_5 = ObjectType.PYRA_5.ordinal();
+  public static final int TRAJ_3 = ObjectType.TRAJ_3.ordinal();
   public static final int DIAM_2 = ObjectType.DIAM_2.ordinal();
   public static final int DIAM_3 = ObjectType.DIAM_3.ordinal();
   public static final int DIAM_4 = ObjectType.DIAM_4.ordinal();
@@ -57,7 +61,4 @@ public class ObjectConstants
   public static final int BAN4_3 = ObjectType.BAN4_3.ordinal();
   public static final int SQU1_3 = ObjectType.SQU1_3.ordinal();
   public static final int SQU2_3 = ObjectType.SQU2_3.ordinal();
-  public static final int CU_323 = ObjectType.CU_323.ordinal();
-  public static final int CU_232 = ObjectType.CU_232.ordinal();
-  public static final int CU_343 = ObjectType.CU_343.ordinal();
   }
diff --git a/src/main/java/org/distorted/objectlib/main/ObjectType.java b/src/main/java/org/distorted/objectlib/main/ObjectType.java
index 7753641b..b5a87d40 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectType.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectType.java
@@ -53,7 +53,7 @@ public enum ObjectType
   PYRA_3 ( TwistyPyraminx.class      , new int[] {3,3,3,3}    , 10, R.drawable.pyra_3s, R.drawable.pyra_3m, R.drawable.pyra_3b, R.drawable.pyra_3h),
   PYRA_4 ( TwistyPyraminx.class      , new int[] {4,4,4,4}    , 17, R.drawable.pyra_4s, R.drawable.pyra_4m, R.drawable.pyra_4b, R.drawable.pyra_4h),
   PYRA_5 ( TwistyPyraminx.class      , new int[] {5,5,5,5}    , 23, R.drawable.pyra_5s, R.drawable.pyra_5m, R.drawable.pyra_5b, R.drawable.pyra_5h),
-  TRAJ_3 ( TwistyTrajber.class       , new int[] {3,3,3}      , 17, R.drawable.diam_2s, R.drawable.diam_2m, R.drawable.diam_2b, R.drawable.diam_2h),
+  TRAJ_3 ( TwistyTrajber.class       , new int[] {3,3,3}      , 17, R.drawable.traj_3s, R.drawable.traj_3m, R.drawable.traj_3b, R.drawable.traj_3h),
   DIAM_2 ( TwistyDiamond.class       , new int[] {2,2,2,2}    , 12, R.drawable.diam_2s, R.drawable.diam_2m, R.drawable.diam_2b, R.drawable.diam_2h),
   DIAM_3 ( TwistyDiamond.class       , new int[] {3,3,3,3}    , 24, R.drawable.diam_3s, R.drawable.diam_3m, R.drawable.diam_3b, R.drawable.diam_3h),
   DIAM_4 ( TwistyDiamond.class       , new int[] {4,4,4,4}    , 32, R.drawable.diam_4s, R.drawable.diam_4m, R.drawable.diam_4b, R.drawable.diam_4h),
diff --git a/src/main/java/org/distorted/objectlib/main/ShapeOctahedron.java b/src/main/java/org/distorted/objectlib/main/ShapeOctahedron.java
index 447ceb67..f4443a69 100644
--- a/src/main/java/org/distorted/objectlib/main/ShapeOctahedron.java
+++ b/src/main/java/org/distorted/objectlib/main/ShapeOctahedron.java
@@ -28,7 +28,7 @@ import org.distorted.library.type.Static4D;
 
 public abstract class ShapeOctahedron extends TwistyObject
 {
-  public static final Static4D DEFAULT_ROT = new Static4D(-0.23377287f, 0.39656782f, 0.029073188f, 0.88726600f);
+  public static final Static4D DEFAULT_ROT = new Static4D(-0.31521368f, 0.36868167f, -0.6488994f, 0.5862124f);
 
   static final int[] FACE_COLORS = new int[]
          {
diff --git a/src/main/res/drawable-nodpi/diam_2b.png b/src/main/res/drawable-nodpi/diam_2b.png
index c0d07cd9..93255e17 100644
Binary files a/src/main/res/drawable-nodpi/diam_2b.png and b/src/main/res/drawable-nodpi/diam_2b.png differ
diff --git a/src/main/res/drawable-nodpi/diam_2h.png b/src/main/res/drawable-nodpi/diam_2h.png
index e89ac565..ced71704 100644
Binary files a/src/main/res/drawable-nodpi/diam_2h.png and b/src/main/res/drawable-nodpi/diam_2h.png differ
diff --git a/src/main/res/drawable-nodpi/diam_2m.png b/src/main/res/drawable-nodpi/diam_2m.png
index 3c94fe2d..72fbe269 100644
Binary files a/src/main/res/drawable-nodpi/diam_2m.png and b/src/main/res/drawable-nodpi/diam_2m.png differ
diff --git a/src/main/res/drawable-nodpi/diam_2s.png b/src/main/res/drawable-nodpi/diam_2s.png
index 14762556..e44932eb 100644
Binary files a/src/main/res/drawable-nodpi/diam_2s.png and b/src/main/res/drawable-nodpi/diam_2s.png differ
diff --git a/src/main/res/drawable-nodpi/diam_3b.png b/src/main/res/drawable-nodpi/diam_3b.png
index 1b4bbdb4..5a0c3fd5 100644
Binary files a/src/main/res/drawable-nodpi/diam_3b.png and b/src/main/res/drawable-nodpi/diam_3b.png differ
diff --git a/src/main/res/drawable-nodpi/diam_3h.png b/src/main/res/drawable-nodpi/diam_3h.png
index 718a12fb..7f335eb4 100644
Binary files a/src/main/res/drawable-nodpi/diam_3h.png and b/src/main/res/drawable-nodpi/diam_3h.png differ
diff --git a/src/main/res/drawable-nodpi/diam_3m.png b/src/main/res/drawable-nodpi/diam_3m.png
index 1b711e78..54c81cda 100644
Binary files a/src/main/res/drawable-nodpi/diam_3m.png and b/src/main/res/drawable-nodpi/diam_3m.png differ
diff --git a/src/main/res/drawable-nodpi/diam_3s.png b/src/main/res/drawable-nodpi/diam_3s.png
index 75834af6..a250d4c8 100644
Binary files a/src/main/res/drawable-nodpi/diam_3s.png and b/src/main/res/drawable-nodpi/diam_3s.png differ
diff --git a/src/main/res/drawable-nodpi/diam_4b.png b/src/main/res/drawable-nodpi/diam_4b.png
index 55ffad4a..105e4a3d 100644
Binary files a/src/main/res/drawable-nodpi/diam_4b.png and b/src/main/res/drawable-nodpi/diam_4b.png differ
diff --git a/src/main/res/drawable-nodpi/diam_4h.png b/src/main/res/drawable-nodpi/diam_4h.png
index 6a9a217d..de20ffe0 100644
Binary files a/src/main/res/drawable-nodpi/diam_4h.png and b/src/main/res/drawable-nodpi/diam_4h.png differ
diff --git a/src/main/res/drawable-nodpi/diam_4m.png b/src/main/res/drawable-nodpi/diam_4m.png
index 5b109124..331bc0f7 100644
Binary files a/src/main/res/drawable-nodpi/diam_4m.png and b/src/main/res/drawable-nodpi/diam_4m.png differ
diff --git a/src/main/res/drawable-nodpi/diam_4s.png b/src/main/res/drawable-nodpi/diam_4s.png
index 750cc01b..58fc6319 100644
Binary files a/src/main/res/drawable-nodpi/diam_4s.png and b/src/main/res/drawable-nodpi/diam_4s.png differ
diff --git a/src/main/res/drawable-nodpi/traj_3b.png b/src/main/res/drawable-nodpi/traj_3b.png
new file mode 100644
index 00000000..6e874d60
Binary files /dev/null and b/src/main/res/drawable-nodpi/traj_3b.png differ
diff --git a/src/main/res/drawable-nodpi/traj_3h.png b/src/main/res/drawable-nodpi/traj_3h.png
new file mode 100644
index 00000000..a00f5ccc
Binary files /dev/null and b/src/main/res/drawable-nodpi/traj_3h.png differ
diff --git a/src/main/res/drawable-nodpi/traj_3m.png b/src/main/res/drawable-nodpi/traj_3m.png
new file mode 100644
index 00000000..2dc9acd9
Binary files /dev/null and b/src/main/res/drawable-nodpi/traj_3m.png differ
diff --git a/src/main/res/drawable-nodpi/traj_3s.png b/src/main/res/drawable-nodpi/traj_3s.png
new file mode 100644
index 00000000..d1c506d6
Binary files /dev/null and b/src/main/res/drawable-nodpi/traj_3s.png differ