commit 046104f572e9802b6790a9c93772a686195ca518
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Mon Oct 4 22:11:38 2021 +0200

    1. Remove 'db level' from objectlib (this belongs to the app!)
    2. change ScreenPlay's 'mObject' to be an ObjectType.

diff --git a/src/main/java/org/distorted/objectlib/main/ObjectControl.java b/src/main/java/org/distorted/objectlib/main/ObjectControl.java
index d0ff8fb4..e0dccae8 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectControl.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectControl.java
@@ -72,7 +72,7 @@ public class ObjectControl
 
     private int mPointer1, mPointer2;
     private float mX1, mY1, mX2, mY2, mX, mY;
-    private boolean mIsAutomatic;
+    private final boolean mIsAutomatic;
 
     private static final Static4D mQuat= new Static4D(-0.25189602f,0.3546389f,0.009657208f,0.90038127f);
     private static final Static4D mTemp= new Static4D(0,0,0,1);
diff --git a/src/main/java/org/distorted/objectlib/main/ObjectType.java b/src/main/java/org/distorted/objectlib/main/ObjectType.java
index 9aa2c794..1389e420 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectType.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectType.java
@@ -33,44 +33,44 @@ import org.distorted.objectlib.objects.*;
 
 public enum ObjectType
   {
-  CUBE_2 ( 2, 12, 12, R.drawable.small_cube2, R.drawable.medium_cube2, R.drawable.big_cube2, R.drawable.huge_cube2),
-  CUBE_3 ( 3, 16, 17, R.drawable.small_cube3, R.drawable.medium_cube3, R.drawable.big_cube3, R.drawable.huge_cube3),
-  CUBE_4 ( 4, 20, 24, R.drawable.small_cube4, R.drawable.medium_cube4, R.drawable.big_cube4, R.drawable.huge_cube4),
-  CUBE_5 ( 5, 24, 28, R.drawable.small_cube5, R.drawable.medium_cube5, R.drawable.big_cube5, R.drawable.huge_cube5),
-  JING_2 ( 2, 11, 11, R.drawable.small_jing2, R.drawable.medium_jing2, R.drawable.big_jing2, R.drawable.huge_jing2),
-  PYRA_3 ( 3, 10, 10, R.drawable.small_pyra3, R.drawable.medium_pyra3, R.drawable.big_pyra3, R.drawable.huge_pyra3),
-  PYRA_4 ( 4, 14, 17, R.drawable.small_pyra4, R.drawable.medium_pyra4, R.drawable.big_pyra4, R.drawable.huge_pyra4),
-  PYRA_5 ( 5, 20, 23, R.drawable.small_pyra5, R.drawable.medium_pyra5, R.drawable.big_pyra5, R.drawable.huge_pyra5),
-  KILO_3 ( 3, 18, 18, R.drawable.small_kilo3, R.drawable.medium_kilo3, R.drawable.big_kilo3, R.drawable.huge_kilo3),
-  KILO_5 ( 5, 33, 33, R.drawable.small_kilo5, R.drawable.medium_kilo5, R.drawable.big_kilo5, R.drawable.huge_kilo5),
-  MEGA_3 ( 3, 21, 21, R.drawable.small_mega3, R.drawable.medium_mega3, R.drawable.big_mega3, R.drawable.huge_mega3),
-  MEGA_5 ( 5, 35, 37, R.drawable.small_mega5, R.drawable.medium_mega5, R.drawable.big_mega5, R.drawable.huge_mega5),
-  ULTI_2 ( 2, 18, 18, R.drawable.small_ulti , R.drawable.medium_ulti , R.drawable.big_ulti , R.drawable.huge_ulti ),
-  DIAM_2 ( 2, 10, 12, R.drawable.small_diam2, R.drawable.medium_diam2, R.drawable.big_diam2, R.drawable.huge_diam2),
-  DIAM_3 ( 3, 18, 24, R.drawable.small_diam3, R.drawable.medium_diam3, R.drawable.big_diam3, R.drawable.huge_diam3),
-  DIAM_4 ( 4, 32, 32, R.drawable.small_diam4, R.drawable.medium_diam4, R.drawable.big_diam4, R.drawable.huge_diam4),
-  DINO_3 ( 3, 10, 10, R.drawable.small_dino , R.drawable.medium_dino , R.drawable.big_dino , R.drawable.huge_dino ),
-  DIN4_3 ( 3,  7,  7, R.drawable.small_din4 , R.drawable.medium_din4 , R.drawable.big_din4 , R.drawable.huge_din4 ),
-  REDI_3 ( 3, 14, 16, R.drawable.small_redi , R.drawable.medium_redi , R.drawable.big_redi , R.drawable.huge_redi ),
-  HELI_3 ( 3, 18, 20, R.drawable.small_heli , R.drawable.medium_heli , R.drawable.big_heli , R.drawable.huge_heli ),
-  SKEW_2 ( 2, 11, 11, R.drawable.small_skew2, R.drawable.medium_skew2, R.drawable.big_skew2, R.drawable.huge_skew2),
-  SKEW_3 ( 3, 17, 21, R.drawable.small_skew3, R.drawable.medium_skew3, R.drawable.big_skew3, R.drawable.huge_skew3),
-  IVY_2  ( 2,  8,  8, R.drawable.small_ivy  , R.drawable.medium_ivy  , R.drawable.big_ivy  , R.drawable.huge_ivy  ),
-  REX_3  ( 3, 16, 19, R.drawable.small_rex  , R.drawable.medium_rex  , R.drawable.big_rex  , R.drawable.huge_rex  ),
-  BAN1_3 ( 3, 16, 16, R.drawable.small_ban1 , R.drawable.medium_ban1 , R.drawable.big_ban1 , R.drawable.huge_ban1 ),
-  BAN2_3 ( 3, 16, 16, R.drawable.small_ban2 , R.drawable.medium_ban2 , R.drawable.big_ban2 , R.drawable.huge_ban2 ),
-  BAN3_3 ( 3, 16, 16, R.drawable.small_ban3 , R.drawable.medium_ban3 , R.drawable.big_ban3 , R.drawable.huge_ban3 ),
-  BAN4_3 ( 3, 16, 16, R.drawable.small_ban4 , R.drawable.medium_ban4 , R.drawable.big_ban4 , R.drawable.huge_ban4 ),
-  SQU1_3 ( 3, 24, 24, R.drawable.small_squa1, R.drawable.medium_squa1, R.drawable.big_squa1, R.drawable.huge_squa1),
-  SQU2_3 ( 3, 24, 24, R.drawable.small_squa2, R.drawable.medium_squa2, R.drawable.big_squa2, R.drawable.huge_squa2),
-  MIRR_2 ( 2, 12, 12, R.drawable.small_mirr2, R.drawable.medium_mirr2, R.drawable.big_mirr2, R.drawable.huge_mirr2),
-  MIRR_3 ( 3, 16, 17, R.drawable.small_mirr3, R.drawable.medium_mirr3, R.drawable.big_mirr3, R.drawable.huge_mirr3),
+  CUBE_2 ( 2, 12, R.drawable.small_cube2, R.drawable.medium_cube2, R.drawable.big_cube2, R.drawable.huge_cube2),
+  CUBE_3 ( 3, 17, R.drawable.small_cube3, R.drawable.medium_cube3, R.drawable.big_cube3, R.drawable.huge_cube3),
+  CUBE_4 ( 4, 24, R.drawable.small_cube4, R.drawable.medium_cube4, R.drawable.big_cube4, R.drawable.huge_cube4),
+  CUBE_5 ( 5, 28, R.drawable.small_cube5, R.drawable.medium_cube5, R.drawable.big_cube5, R.drawable.huge_cube5),
+  JING_2 ( 2, 11, R.drawable.small_jing2, R.drawable.medium_jing2, R.drawable.big_jing2, R.drawable.huge_jing2),
+  PYRA_3 ( 3, 10, R.drawable.small_pyra3, R.drawable.medium_pyra3, R.drawable.big_pyra3, R.drawable.huge_pyra3),
+  PYRA_4 ( 4, 17, R.drawable.small_pyra4, R.drawable.medium_pyra4, R.drawable.big_pyra4, R.drawable.huge_pyra4),
+  PYRA_5 ( 5, 23, R.drawable.small_pyra5, R.drawable.medium_pyra5, R.drawable.big_pyra5, R.drawable.huge_pyra5),
+  KILO_3 ( 3, 18, R.drawable.small_kilo3, R.drawable.medium_kilo3, R.drawable.big_kilo3, R.drawable.huge_kilo3),
+  KILO_5 ( 5, 33, R.drawable.small_kilo5, R.drawable.medium_kilo5, R.drawable.big_kilo5, R.drawable.huge_kilo5),
+  MEGA_3 ( 3, 21, R.drawable.small_mega3, R.drawable.medium_mega3, R.drawable.big_mega3, R.drawable.huge_mega3),
+  MEGA_5 ( 5, 37, R.drawable.small_mega5, R.drawable.medium_mega5, R.drawable.big_mega5, R.drawable.huge_mega5),
+  ULTI_2 ( 2, 18, R.drawable.small_ulti , R.drawable.medium_ulti , R.drawable.big_ulti , R.drawable.huge_ulti ),
+  DIAM_2 ( 2, 12, R.drawable.small_diam2, R.drawable.medium_diam2, R.drawable.big_diam2, R.drawable.huge_diam2),
+  DIAM_3 ( 3, 24, R.drawable.small_diam3, R.drawable.medium_diam3, R.drawable.big_diam3, R.drawable.huge_diam3),
+  DIAM_4 ( 4, 32, R.drawable.small_diam4, R.drawable.medium_diam4, R.drawable.big_diam4, R.drawable.huge_diam4),
+  DINO_3 ( 3, 10, R.drawable.small_dino , R.drawable.medium_dino , R.drawable.big_dino , R.drawable.huge_dino ),
+  DIN4_3 ( 3,  7, R.drawable.small_din4 , R.drawable.medium_din4 , R.drawable.big_din4 , R.drawable.huge_din4 ),
+  REDI_3 ( 3, 16, R.drawable.small_redi , R.drawable.medium_redi , R.drawable.big_redi , R.drawable.huge_redi ),
+  HELI_3 ( 3, 20, R.drawable.small_heli , R.drawable.medium_heli , R.drawable.big_heli , R.drawable.huge_heli ),
+  SKEW_2 ( 2, 11, R.drawable.small_skew2, R.drawable.medium_skew2, R.drawable.big_skew2, R.drawable.huge_skew2),
+  SKEW_3 ( 3, 21, R.drawable.small_skew3, R.drawable.medium_skew3, R.drawable.big_skew3, R.drawable.huge_skew3),
+  IVY_2  ( 2,  8, R.drawable.small_ivy  , R.drawable.medium_ivy  , R.drawable.big_ivy  , R.drawable.huge_ivy  ),
+  REX_3  ( 3, 19, R.drawable.small_rex  , R.drawable.medium_rex  , R.drawable.big_rex  , R.drawable.huge_rex  ),
+  BAN1_3 ( 3, 16, R.drawable.small_ban1 , R.drawable.medium_ban1 , R.drawable.big_ban1 , R.drawable.huge_ban1 ),
+  BAN2_3 ( 3, 16, R.drawable.small_ban2 , R.drawable.medium_ban2 , R.drawable.big_ban2 , R.drawable.huge_ban2 ),
+  BAN3_3 ( 3, 16, R.drawable.small_ban3 , R.drawable.medium_ban3 , R.drawable.big_ban3 , R.drawable.huge_ban3 ),
+  BAN4_3 ( 3, 16, R.drawable.small_ban4 , R.drawable.medium_ban4 , R.drawable.big_ban4 , R.drawable.huge_ban4 ),
+  SQU1_3 ( 3, 24, R.drawable.small_squa1, R.drawable.medium_squa1, R.drawable.big_squa1, R.drawable.huge_squa1),
+  SQU2_3 ( 3, 24, R.drawable.small_squa2, R.drawable.medium_squa2, R.drawable.big_squa2, R.drawable.huge_squa2),
+  MIRR_2 ( 2, 12, R.drawable.small_mirr2, R.drawable.medium_mirr2, R.drawable.big_mirr2, R.drawable.huge_mirr2),
+  MIRR_3 ( 3, 17, R.drawable.small_mirr3, R.drawable.medium_mirr3, R.drawable.big_mirr3, R.drawable.huge_mirr3),
   ;
 
   public static final int NUM_OBJECTS = values().length;
-  public static final int MAX_LEVEL,MAX_SCRAMBLE,MAX_OBJECT_SIZE;
+  public static final int MAX_SCRAMBLE,MAX_OBJECT_SIZE;
 
-  private final int mSize, mDBLevels, mNumScrambles;
+  private final int mSize, mNumScrambles;
   private final int mSmallIcon, mMediumIcon, mBigIcon, mHugeIcon;
 
   private static final ObjectType[] objects;
@@ -79,7 +79,6 @@ public enum ObjectType
     {
     int i = 0;
     objects = new ObjectType[NUM_OBJECTS];
-    int maxLevel   = Integer.MIN_VALUE;
     int maxScramble= Integer.MIN_VALUE;
     int maxSize    = Integer.MIN_VALUE;
 
@@ -88,11 +87,9 @@ public enum ObjectType
       objects[i++] = object;
 
       if( object.mNumScrambles> maxScramble ) maxScramble= object.mNumScrambles;
-      if( object.mDBLevels    > maxLevel    ) maxLevel   = object.mDBLevels;
       if( object.mSize        > maxSize     ) maxSize    = object.mSize;
       }
 
-    MAX_LEVEL       = maxLevel;
     MAX_SCRAMBLE    = maxScramble;
     MAX_OBJECT_SIZE = maxSize;
     }
@@ -116,28 +113,6 @@ public enum ObjectType
     return -1;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static String getObjectList()
-    {
-    StringBuilder list = new StringBuilder();
-
-    for(int i=0; i<NUM_OBJECTS; i++)
-      {
-      if( i>0 ) list.append(',');
-      list.append(objects[i].name());
-      }
-
-    return list.toString();
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public static int getDBLevel(int ordinal)
-    {
-    return ordinal>=0 && ordinal<NUM_OBJECTS ? objects[ordinal].mDBLevels : 0;
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public static int getNumScramble(int ordinal)
@@ -147,10 +122,9 @@ public enum ObjectType
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  ObjectType(int size, int db, int scrambles, int sIcon, int mIcon, int bIcon, int hIcon)
+  ObjectType(int size, int scrambles, int sIcon, int mIcon, int bIcon, int hIcon)
     {
     mSize        = size;
-    mDBLevels    = db;
     mNumScrambles= scrambles;
     mSmallIcon   = sIcon;
     mMediumIcon  = mIcon;